#ifndef KEYBOARDVIEW_H_INCLUDED
#define KEYBOARDVIEW_H_INCLUDED

#include <QWidget>
#include <QPixmap>
#include <QMouseEvent>
#include "ScreenView.h"
#include "compat.h"

class KeyboardView: public QWidget {
public:
  KeyboardView( ScreenView *screenView0, QWidget *parent = 0 ):
	QWidget(parent), screenView(screenView0), m_nKeyboardKeyPressed(0),
        pm("keyboard.bmp") {

	resize( pm.size() );
	show();
  }

  BYTE getKeyByPoint( int x, int y );

protected:
  ScreenView *screenView;

  static const WORD m_arrKeyboardKeys[];
  static const int m_nKeyboardKeysCount;
  BYTE m_nKeyboardKeyPressed; // UKNC scan-code for the key pressed, or 0

  QPixmap pm;
  void paintEvent( QPaintEvent *ev );
  void mousePressEvent( QMouseEvent *ev );
  void mouseReleaseEvent( QMouseEvent *ev );
};

#endif // KEYBOARDVIEW_H_INCLUDED
