#ifndef SCREENVIEW_H_INCLUDED
#define SCREENVIEW_H_INCLUDED

#include <QWidget>
#include <QImage>

#include "Common.h"
#include "Views.h"

#define KEYEVENT_QUEUE_SIZE 32

class ScreenView: public QWidget {
public:
  ScreenView( QWidget *parent = 0 );
  void prepareScreen();
  ScreenViewMode getMode() { return m_ScreenMode; }
  void setMode( ScreenViewMode newMode ) { m_ScreenMode = newMode; }
  int getHeightMode() { return m_ScreenHeightMode; }
  void setHeightMode( int newMode );
  void scanKeyboard();
  void putKeyEventToQueue( BYTE keycode, bool pressed );
  void saveScreenshot( QString sFileName );
protected:
  ScreenViewMode m_ScreenMode;
  int m_ScreenHeightMode; // 1 - Normal height, 2 - Double height
  static const DWORD StandardRGBColors[16], StandardGRBColors[16], GrayColors[16];

  WORD m_ScreenKeyQueue[KEYEVENT_QUEUE_SIZE];
  int m_ScreenKeyQueueTop, m_ScreenKeyQueueBottom, m_ScreenKeyQueueCount;

  BYTE translateKeyToUkncScan( int key, int modifiers );
  void putKeyEventToQueue(WORD keyevent);
  WORD getKeyEventFromQueue();

  QImage img;
  void paintEvent( QPaintEvent *ev );
  void keyPressEvent( QKeyEvent *ev );
  void keyReleaseEvent( QKeyEvent *ev );
};

#endif // SCREENVIEW_H_INCLUDED
