#include <QApplication>
#include <QMainWindow>

#include "Common.h"
#include "Emulator.h"
#include "UKNCBTL.h"
#include "MainWindow.h"

void AlertWarning(LPCTSTR warning) {
  puts( warning );
}

const TCHAR* REGISTER_NAME[8] = { _T("R0"), _T("R1"), _T("R2"), _T("R3"), _T("R4"), _T("R5"), _T("SP"), _T("PC") };

int main( int argc, char **argv ) {
  QApplication qa( argc, argv );
  qa.setOrganizationName( "vr5" );
  qa.setApplicationName( "UKNCEverywhere" );

  if (!InitEmulator()) return FALSE;

  MainWindow w;

  if ( Settings_GetAutostart() ) {
	Emulator_Start();
	w.updateMenu();
  }

  while ( !w.isHidden() ) {
	if ( g_okEmulatorRunning && Emulator_SystemFrame( w.screenView() ) )
		w.systemFrame();

	QApplication::processEvents();
  }

  return 0;
}
