#ifndef COMPAT_H_INCLUDED
#define COMPAT_H_INCLUDED

#ifndef WIN32
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

typedef unsigned int DWORD;
typedef unsigned int UINT;
typedef unsigned short WORD;
typedef unsigned char BYTE;
typedef bool BOOL;
typedef char TCHAR;
typedef const char* LPCTSTR;
typedef char* LPTSTR;
typedef int LRESULT;
typedef int LPARAM;
typedef int WPARAM;
typedef void* LPTR;
typedef int HANDLE;
typedef void* HFONT;
typedef void* HDC;
typedef void* HWND;
typedef void* HINSTANCE;
typedef void* HICON;

#define HIWORD(a) ((a) >> 16)
#define HIBYTE(a) (((a) >> 8) & 0xff)
#define LOBYTE(a) ((a) & 0xff)
#define MAKEWORD(low,high) ((((high) & 0xff) << 8) | ((low) & 0xff))

#define TRUE true
#define FALSE false

#define INVALID_HANDLE_VALUE -1

//#define ASSERT assert
#define _T
#define CALLBACK

#define LocalAlloc(flags,size) calloc(size, 1)
#define LocalFree(ptr) free(ptr)
#define ZeroMemory(ptr,size) memset(ptr, 0, size)
#define CopyMemory(dest,src,size) memcpy(dest,src,size)
#define _snwprintf_s(buf,sz1,sz2,rest...) snprintf(buf,sz1,rest)
#define lstrcpy strcpy
#define wcscpy_s(dest,size,src) strncpy(dest,src,size)
#define wcsrchr strchr
#define _wcsicmp strcasecmp

#define CloseHandle close
#define ReadFile(fd,buf,count,count_out,overlap) do { int bytes = read(fd,buf,count); if ( count_out ) *count_out = bytes; } while(0)
#define WriteFile(fd,buf,count,count_out,overlap) do { int bytes = write(fd,buf,count); if ( count_out ) *count_out = bytes; } while(0)
#define SetFilePointer(fd,offs,offs_high,where) lseek(fd,offs,where)
#define SetEndOfFile(fd) do { off_t pos = lseek(fd,0,SEEK_CUR); ftruncate(fd,pos); } while(0)

inline int GetFileSize(int fd, long long *lsz) { 
  off_t pos = lseek(fd,0,SEEK_CUR);

  off_t sz = lseek(fd,0,SEEK_END);

  lseek(fd,pos,SEEK_SET);

  if ( lsz ) *lsz = sz;
  return sz;
}

#define FILE_BEGIN SEEK_SET

#endif

#endif // COMPAT_H_INCLUDED
